# Use cases with `RagConnect`

## MPM4CPS Paper - Codename 'Ros2Rag'

In the publication [*"Connecting conceptual models using Relational Reference Attribute Grammars"*](https://doi.org/10.1145/3417990.3421437), a use case involving a simulated robot arm and two different models connected to it was shown.
One model was used to ensure a low speed of the robot when within a safety zone (purple boxes in the picture below), and the other model executes a workflow to control the robot.

![Screenshot of Gazebo](img/robo3d.png)

[📽 Recording of the simulated robot during the use case](img/moving-robot.mp4)

This paper was presented on October, 16h during the [MPM4CPS workshop](https://msdl.uantwerpen.be/conferences/MPM4CPS/2020/) within the [MODELS 2020 conference](https://conf.researchr.org/home/models-2020). For more information, see the [presented slides](img/mpm4cps-slides.pdf) or the [a recording of the session](https://youtu.be/Hgc1qFfmr44?t=1220).

There is also a [poster](img/poster.pdf) and a [pre-recorded presentation](img/poster-presentation.mp4) of this poster.

The repository with the used source code can be found at: <https://git-st.inf.tu-dresden.de/ceti/ros/mpm4cps2020>
The usage is dockerized, so starting the application only involves the commands listed below.
As ROS takes some time to start up, it is best to use separate terminals for the three applications (ROS, Safety-Model, Goal-Model):

```bash
# Preparation (only need once)
./prepare-docker-compose.sh
docker-compose up -d mosquitto  # Starts the MQTT broker

# Terminal 1: ROS
docker-compose up --build ros
# Wait until you see no more new logging output

# Terminal 2: Safety-Model
docker-compose up rag_app

# Terminal 3: Goal-Model
docker-compose up rag_goal
```
